// Copyright 2002 Macromedia, Inc. and its licensors.  All Rights Reserved.
//
// Use and/or redistribution of this file, in whole or in part, is subject
// to the Macromedia Sample Files License, which was distributed with this file.
//
#initclip 
//
//
/*
//
CatalogView class


	This file is associated with a library movie clip symbol.

	#include info for this file:

			FLA:				main.fla

			Layer:				Actions : Class

			Frame:				1

			Library Symbol:		adWidget_mc

			Library Path:		widgetGroup/adWidget/adWidget_mc
//
*/
//

function CatalogView() {
	_global.catalogView = this;
	this.init();
}

// associate the CatalogView class with the authortime adWidget_mc instance
Object.registerClass("CatalogViewSymbol", CatalogView);


CatalogView.prototype = new MovieClip();

CatalogView.prototype.init = function() {
	this.categories_lb = this.categoriesHolder_mc.attachMovie("FListBoxSymbol", "categories_lb", 1);
	this.categories_lb.setSize(300,200);
	this.categories_lb.setChangeHandler("categoryChanged", this);
	this.products_lb = this.productsHolder_mc.attachMovie("FListBoxSymbol", "products_lb", 1);
	this.products_lb.setSize(300,200);
	this.products_lb.setChangeHandler("productChanged", this);
	this.items_lb = this.itemsHolder_mc.attachMovie("FListBoxSymbol", "items_lb", 1);
	this.items_lb.setSize(300,200);
	this.items_lb.setChangeHandler("itemChanged", this);
}

CatalogView.prototype.startListening = function(catalog) {
	this.catalog = catalog;
	this.catalog.addListener(this);
}

CatalogView.prototype.listenToBroadcaster = function(event, data) {
	debugBreak("listening");
	if(event == "categories") {
		this.categories_lb.removeAll();
		_global.DataGlue.bindFormatStrings(this.categories_lb, data.rs, "#CATEGORYDISPLAYNAME");
	}
	else if(event == "products" && data.id == this.pendingCatOID) {
		this.products_lb.removeAll();
		_global.DataGlue.bindFormatStrings(this.products_lb, data.rs, "#NAME");
	}
	else if(event == "items" && data.prodoid == this.pendingProdOID) {
		this.items_lb.removeAll();
		_global.DataGlue.bindFormatFunction(this.items_lb, data.rs, this.formatItem);
	}
}

CatalogView.prototype.categoryChanged = function(the_lb) {
	var itm = the_lb.getSelectedItem();
	this.products_lb.removeAll();
	this.items_lb.removeAll();
	this.pendingCatOID = itm.data["CATEGORYOID"];
	this.catalog.getProducts(this.pendingCatOID);
}

CatalogView.prototype.productChanged = function(the_lb) {
	var itm = the_lb.getSelectedItem();
	this.items_lb.removeAll();
	this.pendingProdOID = itm.data["PRODUCTOID"];
	this.catalog.getItems(this.pendingProdOID);
}

CatalogView.prototype.formatItem = function(item_record) {
	debugBreak("formatting");
	return { label : item_record["ITEMNAME"] + " " + _global.formatForCurrency(item_record["LISTPRICE"]), 
				data : record };
}

CatalogView.prototype.itemChanged = function(the_lb) {
}

#endinitclip
