// Copyright 2002 Macromedia, Inc. and its licensors.  All Rights Reserved.
//
// Use and/or redistribution of this file, in whole or in part, is subject
// to the Macromedia Sample Files License, which was distributed with this file.
//
//--------------------------------------------------------------------------------
/*
                     
OrderModel class

	The OrderModel class implements the model and controller mechanism of the
	Model/View/Controller (MVC) architecture.

	The OrderModel class handles all communication with the server needed to
	place an order.  As such, it functions as a Model.

	Via extending the Broadcaster class, the OrderModel class also functions as a
	controller for all UI objects that need to respond to the order process.

	The OrderModel class is meant to be used as a singleton.  In other words, it
	is not instantiated in the program.  All access takes place through the
	single _global.orderer instance.

	This file is a pure ActionScript object.

	#include info for this file:

			FLA:				main.fla

			Layer:				Actions : Class Definitions

			Frame:				1

			Library Symbol:		N/A (included on main timeline)

			Library Path:		
*/
//--------------------------------------------------------------------------------
//----------------------------------------------------------------------
//OrderModel
//----------------------------------------------------------------------
function OrderModel() {
}

OrderModel.prototype = new Broadcaster();

_global.orderer = new OrderModel();

//----------------------------------------------------------------------
// init
//----------------------------------------------------------------------
OrderModel.prototype.init = function (gateway_conn, uri) {
	this.orderService = gateway_conn.getService(uri, this);
}

//----------------------------------------------------------------------
// placeOrder_Status
//----------------------------------------------------------------------
OrderModel.prototype.placeOrder_Status = function (result) {
	this.broadcast("orderPlacedStatus", result);
}

//----------------------------------------------------------------------
// placeOrder_Result
//----------------------------------------------------------------------
OrderModel.prototype.placeOrder_Result = function (result) {
	this.broadcast("orderPlaced", result);
}

//----------------------------------------------------------------------
// placeOrder
//----------------------------------------------------------------------
OrderModel.prototype.placeOrder = function (useroid, cartoid) {
	this.orderService.placeOrder(useroid, cartoid);
}
//Authors: Brian Kruse (bkruse), Buck Bito (bbito)
