// Copyright 2002 Macromedia, Inc. and its licensors.  All Rights Reserved.
//
// Use and/or redistribution of this file, in whole or in part, is subject
// to the Macromedia Sample Files License, which was distributed with this file.
//
//--------------------------------------------------------------------------------
/*
StringResourcesModel class

	The StringResourcesModel class implements the model and controller mechanism of the
	Model/View/Controller (MVC) architecture.

	The StringResourcesModel class retrieves all of the application's strings in a structure.
	As such, it functions as a Model.

	Via extending the Broadcaster class, the StringResourcesModel class also functions as a
	controller that notifies listeners when the application strings are available.

	The StringResourcesModel class is meant to be used as a singleton.  In other words, it
	is not instantiated in the program.  All access takes place through the
	single _global.stringResourcesRetriever instance.

	This file is a pure ActionScript object.

	#include info for this file:

			FLA:				main.fla

			Layer:				Actions : Class Definitions

			Frame:				1

			Library Symbol:		N/A (included on main timeline)

			Library Path:		
*/
//--------------------------------------------------------------------------------
//----------------------------------------------------------------------
//StringResourcesModel
//----------------------------------------------------------------------
function StringResourcesModel() {
	this.locale_str = _global.locale_str != null && _global.locale_str != "" ? 
		_global.locale_str : "en_US";
}

StringResourcesModel.prototype = new Broadcaster();

_global.stringResourcesRetriever = new StringResourcesModel();

//----------------------------------------------------------------------
// init
//----------------------------------------------------------------------
StringResourcesModel.prototype.init = function (gateway_conn, uri) {
	this.appStringService = gateway_conn.getService(uri, this);
}

//----------------------------------------------------------------------
// getAppStrings
//----------------------------------------------------------------------
StringResourcesModel.prototype.getAppStrings = function () {
	this.appStringService.getAppStrings(this.locale_str);
}

//----------------------------------------------------------------------
// getAppStrings_Status
//----------------------------------------------------------------------
StringResourcesModel.prototype.getAppStrings_Status = function ( result ) {
	this.broadcast("appStringsStatus", result);
}

//----------------------------------------------------------------------
// getAppStrings_Result
//----------------------------------------------------------------------
StringResourcesModel.prototype.getAppStrings_Result = function ( result ) {
	_global.appStrings = result;
	this.broadcast("appStringsResult", result);
}

//----------------------------------------------------------------------
// getAboutUsStrings
//----------------------------------------------------------------------
StringResourcesModel.prototype.getAboutUsStrings = function () {
	this.appStringService.getAboutUsStrings();
}

//----------------------------------------------------------------------
// getAboutUsStrings_Status
//----------------------------------------------------------------------
StringResourcesModel.prototype.getAboutUsStrings_Status = function ( result ) {
	this.broadcast("getAboutUsStringsStatus", result);
}

//----------------------------------------------------------------------
// getAboutUsStrings_Result
//----------------------------------------------------------------------
StringResourcesModel.prototype.getAboutUsStrings_Result = function ( result ) {
	this.broadcast("getAboutUsStringsResult", result);
}

//----------------------------------------------------------------------
// getLegalStrings
//----------------------------------------------------------------------
StringResourcesModel.prototype.getLegalStrings = function () {
	this.appStringService.getLegalStrings();
}

//----------------------------------------------------------------------
// getLegalStrings_Status
//----------------------------------------------------------------------
StringResourcesModel.prototype.getLegalStrings_Status = function ( result ) {
	this.broadcast("getLegalStringsStatus", result);
}

//----------------------------------------------------------------------
// getLegalStrings_Result
//----------------------------------------------------------------------
StringResourcesModel.prototype.getLegalStrings_Result = function ( result ) {
	this.broadcast("getLegalStringsResult", result);
}

//----------------------------------------------------------------------
// getAffiliateStrings
//----------------------------------------------------------------------
StringResourcesModel.prototype.getAffiliateStrings = function () {
	this.appStringService.getAffiliateStrings();
}

//----------------------------------------------------------------------
// getAffiliateStrings_Status
//----------------------------------------------------------------------
StringResourcesModel.prototype.getAffiliateStrings_Status = function ( result ) {
	this.broadcast("getAffiliateStringsStatus", result);
}

//----------------------------------------------------------------------
// getAffiliateStrings_Result
//----------------------------------------------------------------------
StringResourcesModel.prototype.getAffiliateStrings_Result = function ( result ) {
	this.broadcast("getAffiliateStringsResult", result);
}

//Authors: Brian Kruse (bkruse), Buck Bito (bbito)
