// Copyright 2002 Macromedia, Inc. and its licensors.  All Rights Reserved.
//
// Use and/or redistribution of this file, in whole or in part, is subject
// to the Macromedia Sample Files License, which was distributed with this file.
//
//----------------------------------------------------------------------
//
// main function definitions- functions that initialize "global" context
// settings
//
//
/*
	This file contains functions only, and is associated with the main timeline.

	#include info for this file:

			FLA:				main.fla

			Layer:				Actions : Class Definitions

			Frame:				1

			Library Symbol:		N/A (included on main timeline)

			Library Path:		
*/
//


//----------------------------------------------------------------------
//	initConnection
//
// 		This function sets up the gateway connection as
// 		generically as possible, and sets up the model objects
// 		that marshall all Flash Remoting calls and broadcast
// 		the results to listening UI objects.
//----------------------------------------------------------------------
function initConnection()
{	
	// :NOTE: - The URL below is used by Test-Movie mode of the
	//			Flash Authoring environment only
	var testServer = "http://localhost:8500/";
	
	if(_global.gatewayURIDir_str == null || _global.gatewayURIDir_str == "") {
		_global.gatewayURIDir_str = "flashservices/gateway";
	}
	//NetServices.setDefaultGatewayUrl(testServer+_global.gatewayURIDir_str);
NetServices.setDefaultGatewayUrl("http://www.simonf.com/cgi-bin/flap/petmarket.pl");
	
    var gateway_conn = NetServices.createGatewayConnection();
	gateway_conn.addHeader("playerInfo", false, 
			{ os : System.capabilities.os, manufacturer : System.capabilities.manufacturer,
								version : System.capabilities.version });

	
	// This function is called whenever server communication fails.  Because this
	// function is called the gateway level it is considered to be catastrophic failure
	// if it is invoked.
	gateway_conn.onStatus = function(result) {
		_global.dieToErrorPage(_global.statusToQS(result));
	}

	if(_global.serviceURIsPrefix_str == null || _global.serviceURIsPrefix_str == "") {
		_global.serviceURIsPrefix_str = "petmarket.api";
	}
	_global.catalog.init(gateway_conn, _global.serviceURIsPrefix_Str + ".catalogservice");
	_global.cart.init(gateway_conn, _global.serviceURIsPrefix_Str + ".cartservice");
	_global.user.init(gateway_conn, _global.serviceURIsPrefix_Str + ".userservice");
	_global.orderer.init(gateway_conn, _global.serviceURIsPrefix_Str + ".orderservice");
	_global.stringResourcesRetriever.init(gateway_conn, _global.serviceURIsPrefix_Str + ".stringresourcesservice");
	
	// This shared object will hold a cart OID which we can send to the server to
	// retrieve a stored cart
	_global.currUserSO = SharedObject.getLocal("petMarketUser_"+_global.backend_str);

	// The remotingTimer_mc is a Movie Clip that causes the application to die to an error page
	// if the there has not been a response from the flash remoting server after 
	// a specified length of time following the first flash remoting request.
	_global.remotingTimer_mc = this.createEmptyMovieClip("remotingTimer", 124442);
	_global.remotingTimer_mc.stop();
	_global.remotingTimer_mc.framesPlayed = 0;
	_global.timeoutLength = new Number(_global.timeoutLength);
	if(_global.timeoutLength == 0 || isNaN(_global.timeoutLength)) {
		_global.timeoutLength = 20;
	}
	// Time out formula = 20 frames per second *  timeoutLength
  	_global.remotingTimer_mc.timeOutFrameCount = 20 * _global.timeoutLength;
	_global.timeoutLengthMS = _global.timeoutLength*1000;
	// This defines a function for remotingTimer_mc that will begin the timeout detection
	// when the function is invoked.
	_global.remotingTimer_mc.doTimeoutDetection = function() {
		this.startedAt = new Date().getTime();
		this.play();
	}
	// This defines a function for remotingTimer_mc that will continually check for 
	// timeout while the remotingTimer_mc is playing.  Because remotingTimer_mc is
	// initially stopped, the function will not execute until 
	// _global.remotingTimer_mc.doTimeoutDetection() is called.
	_global.remotingTimer_mc.onEnterFrame = function () {
		var now = new Date().getTime();
		if(this.framesPlayed >= this.timeOutFrameCount && this.framesPlayed % 20 == 0 &&
				now - this.startedAt >= _global.timeoutLengthMS) {
			delete this.onEnterFrame;
			_global.dieToErrorPage("timeout=true");
			this.stop();
		}
		else {
			++this.framesPlayed;
		}
	}

	// see ViewClasses/MainTimeline.as for setupListeners definition
	this.setupListeners();

}

//Authors: Brian Kruse (bkruse), Buck Bito (bbito)
