// Copyright 2002 Macromedia, Inc. and its licensors.  All Rights Reserved.
//
// Use and/or redistribution of this file, in whole or in part, is subject
// to the Macromedia Sample Files License, which was distributed with this file.
//
//----------------------------------------------------------------------
//
// Widget initialization function definitions- these functions initialize
// the widget group on the right hand side of the UI.
// 
//
/*
	This file contains functions only, and is not associated with a movie clip.

	#include info for this file:

			FLA:				main.fla

			Layer:				Actions : Class Definitions

			Frame:				1

			Library Symbol:		N/A (included on main timeline)

			Library Path:		
*/
//
//
//----------------------------------------------------------------------
//initAdWidget
//----------------------------------------------------------------------
function initAdWidget() {
	adWidget_mc.init(_global.appStrings);
	adWidget_mc.startListening(_global.catalog);
}

//----------------------------------------------------------------------
//initHistWidget
//----------------------------------------------------------------------
function initHistWidget() {
	historyWidget_mc.init(_global.toolTip_mc, _global.tabController, _global.appStrings);
	historyWidget_mc.startListening(_global.catalog, _global.cart);
}

//----------------------------------------------------------------------
//initSearchWidget
//----------------------------------------------------------------------
function initSearchWidget() {
	searchWidget_mc.init(_global.tabController, _global.appStrings, _global.catalog);
	searchWidget_mc.startListening(_global.catalog);
}

//----------------------------------------------------------------------
//initCartWidget
//----------------------------------------------------------------------
function initCartWidget() {
	cartWidget_mc.init(_global.tabController, _global.appStrings, _global.cart, _global.catalog);
	cartWidget_mc.startListening(_global.cart);
	_global.itemBrowsing_mc.setDragTarget(cartWidget_mc);
}

//----------------------------------------------------------------------
//initWidgetGroup
//
// Set up the widget group, which controls the right hand side animation.
//----------------------------------------------------------------------
function initWidgetGroup() {
	_global.widgetGroupObj.addWidget(historyWidget_mc);
	_global.widgetGroupObj.addWidget(searchWidget_mc);
	_global.widgetGroupObj.addCartWidget(cartWidget_mc, 36, 2);
	_global.widgetGroupObj.setAdWidget(adWidget_mc, adMask_mc, 261, 442);
	_global.widgetGroupObj.setCartBottom_mc(cartBottom_mc, -4, 556, 2);
	_global.widgetGroupObj.startListening(_global.cart);
}
//Authors: Brian Kruse (bkruse), Buck Bito (bbito)
