// Copyright 2002 Macromedia, Inc. and its licensors.  All Rights Reserved.
//
// Use and/or redistribution of this file, in whole or in part, is subject
// to the Macromedia Sample Files License, which was distributed with this file.
//
/*
	This file contains functions only, and is associated with the main timeline.

	It contains code that shell.swf calls while setting up the application.

	#include info for this file:

			FLA:				shell.fla

			Layer:				Actions : Init Functions

			Frame:				1

			Library Symbol:		N/A (included on main timeline)

			Library Path:		
*/
//----------------------------------------------------------------------
// checkPlayerVersion
//----------------------------------------------------------------------
function checkPlayerVersion() 
{
	if(!this.foundReqs) {
		this.reqMajor = 6;
		this.reqMinor = 40;
	}
	if(this.player_req_failure_uri == null) {
		this.player_req_failure_uri = "upgradeFlash.html";
	}
	if(this.reportedMajor < this.reqMajor || 
		(this.reportedMajor == this.reqMajor && 
			this.reportedMinor < this.reqMinor)) {
		this.stop();
		getURL(this.player_req_failure_uri, "_top");
	}
	else { 
		this.play();
	}
}

//----------------------------------------------------------------------
//loadFonts
//----------------------------------------------------------------------
function loadFonts()
{
	loadSwf("embed_fonts.swf", embed_fonts_mc, "loadedFonts");
}

//----------------------------------------------------------------------
//loadComponents
//----------------------------------------------------------------------
function loadComponents()
{
	loadSwf("fui_components.swf", fui_components_mc, "loadedComponents");
}

//----------------------------------------------------------------------
//loadMain
//----------------------------------------------------------------------
function loadMain()
{
	loadSwf("main.swf", main_mc, "loadedMain");
}

//----------------------------------------------------------------------
//loadSwf
//----------------------------------------------------------------------
function loadSwf(swfToLoad, targetMC, loadedStateLabel)
{
	// _global.testMovieMain is set in main.fla's utility.as file
	// it will be set to true if main.swf is running outside of shell.swf
	if(_global.testMovieMain && swfToLoad == "main.swf"){
		gotoAndStop(loadedStateLabel);
		_parent.play();
	}
	else{
		if (_global.loadingStatus == undefined){
			_global.loadingStatus = new Object();
		}
		_global.loadingStatus.currentTarget = targetMC;
		_global.loadingStatus.loadedStateLabel = loadedStateLabel;
		targetMC.loadMovie(swfToLoad);
		if(this.loadPoller == undefined){
			this.createEmptyMovieClip("loadPoller", 10);
		}
		this.loadPoller.onEnterFrame = updateLoading;
	}
}

//----------------------------------------------------------------------
//updateLoading
//
// This is an onEnterFrame handler and is called repeatedly by the 
// player.
//----------------------------------------------------------------------
function updateLoading()
{
	var targetMC = _global.loadingStatus.currentTarget;
	var loadedStateLabel = _global.loadingStatus.loadedStateLabel;
	var bytesLoaded = targetMC.getBytesLoaded();
	var bytesTotal = targetMC.getBytesTotal();
	if(bytesTotal > 4 && bytesLoaded >= bytesTotal){
		updateLoadingFeedback(false, targetMC, bytesLoaded, bytesTotal);
		gotoAndStop(loadedStateLabel);
	}
	else{
		updateLoadingFeedback(true, targetMC, bytesLoaded, bytesTotal);
	}
}

//----------------------------------------------------------------------
//mainIsLoaded
//----------------------------------------------------------------------
function mainIsLoaded(){
	delete loadPoller.onEnterFrame;
	stop();
}

//----------------------------------------------------------------------
//updateLoadingFeedback
//----------------------------------------------------------------------
function updateLoadingFeedback(isLoading, targetMC, bytesLoaded, bytesTotal)
{
	var upperCaseName_str = targetMC._name.toUpperCase();
	if(isLoading && feedbackMode != "mainInit"){
		showSplashScreen();
		splash_mc.loadingMsg_txt.text = _global.LOADING_str;
		splash_mc.loadingStatus_txt.text = _global[upperCaseName_str+"_LOADING_MSG_str"];
	}
}

//----------------------------------------------------------------------
//setInitFeedback
//----------------------------------------------------------------------
_global.setInitFeedback = function(mode, elt_str)
{
	if(mode != null){
		feedbackMode = "mainInit";
		showSplashScreen();
		splash_mc.loadingMsg_txt.text = (mode == "load") ? _global.LOADING_str : _global.INITIALIZING_str;
		splash_mc.loadingStatus_txt.text = elt_str;
	}
	else{
		showSplashScreen(false);
		this.feedBackMode = "";
	}
}

//----------------------------------------------------------------------
//showSplashScreen
//----------------------------------------------------------------------
showSplashScreen = function(show)
{
	if(show == false){
		this.splash_mc.removeMovieClip();
		this.splashInited = false;
	}
	else{
		if(! this.splashInited){
			this.splashInited = true;
			this.attachMovie("shellSplash_mc", "splash_mc", 1);
			splash_mc._x = 207;
			splash_mc._y = 92;
			splash_mc.splashBG_mc._alpha = 75;
			splash_mc.logoSplash_mc.gotoAndStop(_global.backend_str);
			splash_mc.onPress = function(){};
			splash_mc.useHandCursor = false;
		}
	}
}

//----------------------------------------------------------------------
//getShellInitData
//
// This loads the application initialization data from an XML file.
//
// It pauses shell.swf execution until the load has completed.
//
//----------------------------------------------------------------------
function getShellInitData(nextLabel)
{
	_global.shellInitData = new XML();
	_global.shellInitData.ignoreWhite = true;
	_global.shellInitData.shellTL = this;
	var split1 = System.capabilities.version.split(" ");
	this.reportedPlatform = split1[0];
	var split2 = split1[1].split(",");
	this.reportedMajor = split2[0];
	this.reportedMinor = split2[2];
	_global.shellInitData.onLoad = function()
	{
		// parse backend config XML
		var node = this.firstChild.firstChild; // this is firstChild of <petMarket_init> node
		while(node != null){
			if(node.nodeName == "locale"){
				_global.locale_str = node.attributes["type"];
			}
			else if(node.nodeName == "backend_config"){
				_global.backend_str = _global.productImageMaskFrame_str = node.attributes["currBackend"];
				_global.adImagePath_str = node.attributes["adImagePath"];
				var currBackendNode = node.firstChild;
				while(currBackendNode.attributes["type"] != _global.backend_str){
					currBackendNode = currBackendNode.nextSibling;
				}
				var subNode = currBackendNode.firstChild;
				while(subNode != null){
					if(subNode.nodeName == "productsInfo") {
						_global.productImagePath_str = subNode.attributes["imagePath"];
						_global.productImageXOffset = Number(subNode.attributes["imageXOffset"]);
						_global.productImageYOffset = Number(subNode.attributes["imageYOffset"]);
					}
					else if(subNode.nodeName == "serviceURIs") {
						_global.serviceURIsPrefix_str = subNode.attributes["prefix"];
					}
					else if(subNode.nodeName == "gatewayURI") {
						_global.gatewayURIDir_str = subNode.attributes["dir"];
					}
					else if(subNode.nodeName == "globalStrings") {
						_global.appTitle_str = subNode.attributes["appTitle"];
						_global.appSubtitle_str = subNode.attributes["appSubtitle"];
					}
					subNode = subNode.nextSibling;
				}
			}
			else if(node.nodeName == "loading_strings"){
				var subNode = node.firstChild;
				while(subNode != null){
					_global[subNode.nodeName] = subNode.firstChild.nodeValue;
					subNode = subNode.nextSibling;
				}
			}
			else if(node.nodeName == "log_errors"){
				_global.logErrorURI = node.attributes["uri"];
			}
			else if(node.nodeName == "timeout"){
				_global.timeoutLength = node.attributes["length"];
			}
			else if(!this.shellTL.foundReqs && node.nodeName == "player_req") {
				if(this.shellTL.reportedPlatform  == node.attributes["platform"]) {
					this.shellTL.foundReqs = true;
					this.shellTL.reqMajor = node.attributes["major"];
					this.shellTL.reqMinor = node.attributes["minor"];
				}
			}
			else if(node.nodeName == "player_req_failure") {
				this.player_req_failure_uri = node.attributes["uri"];
			}
			node = node.nextSibling
		}
		gotoAndPlay(nextLabel);
		logoMain_mc.gotoAndStop(_global.backend_str);
	}
	_global.shellInitData.load("shell_init.xml");
}

//----------------------------------------------------------------------
//	function initSubtitle
//----------------------------------------------------------------------
function initSubtitle()
{
	this.appSubtitle_mc.subtitle_txt.text = this.appSubtitle_mc.shadow_txt.text = _global.appSubtitle_str;
}

//----------------------------------------------------------------------
//	function setGlobalErrorPage
//
// Retrieves the error page URL from the HTML FlashVars parameters
//----------------------------------------------------------------------
function setGlobalErrorPage()
{
	var errorPage = (_root.errorPage == undefined) ? "error.html" : _root.errorPage;
	_global.errorPage = errorPage;
}
setGlobalErrorPage();
//Authors: Brian Kruse (bkruse), Buck Bito (bbito)
